Summary: An extremely capable system configuration tool.
Name: linuxconf
Version: 1.18
Release: 2mdk
Copyright: GPL
Group: System/Configuration/Other
Source: ftp://ftp.solucorp.qc.ca/pub/linuxconf/src/%{name}-%{PACKAGE_VERSION}.src.tar.bz2
Source1: linuxconf.power.png
Patch0:	linuxconf-1.17r9-mdkconf.patch.bz2
Patch2: linuxconf-1.17r4-mdkpath.patch.bz2
Patch4: linuxconf-1.17r4-logrotatemdk.patch.bz2
Patch5: linuxconf-adsl.patch.bz2
Patch100: linuxconf-xauth.patch.bz2
Patch102: linuxconf-sparc.patch.bz2
Patch103: linuxconf-1.17r9-askrunlevel-interactive.patch.bz2
Patch104: linuxconf-1.18-nolilo.patch.bz2
Patch200: linuxconf-wvf.patch.bz2
Patch300: linuxconf-1.17r4-boutonsfrancais.patch.bz2
Patch301: linuxconf-1.17r4-traduction.patch.bz2
Patch302: linuxconf-1.17r4-spellingerror.patch.bz2
Patch303: dhcpd.patch.bz2
BuildRequires: gd-devel

Url: http://www.solucorp.qc.ca/linuxconf/
BuildRoot: %{_tmppath}/linuxconf-root
Autoprov: false
%define MODULE_API_VERSION 15
Provides: LINUXCONFAPIREV%{MODULE_API_VERSION}
Requires: initscripts >= 3.79
Prereq: /usr/sbin/groupadd
Prereq: /etc/services
Prereq: /bin/mktemp
Prereq: sh-utils fileutils textutils grep chkconfig mandrake-release
Prereq: pam
Obsoletes: usercfg fstool cabaret

%description
Linuxconf is an extremely capable system configuration tool.  Linuxconf
provides four different interfaces for you to choose from:  command line,
character-cell (like the installation program), an X Window System based
GUI and a web-based interface.  Linuxconf can manage a large proportion
of your system's operations, including networking, user accounts, file
systems, boot parameters, and more.

Linuxconf will simplify the process of configuring your system.  Unless
you are completely happy with configuring your system manually, you should
install the linuxconf package and use linuxconf instead.

%package devel
Summary: The tools needed for developing linuxconf modules.
Group: Development/C
%description devel
Linuxconf is an extremely capable system configuration tool.
It provides a variety of interfaces through which you can configure
your Linux system and manage a large proportion of the system's
operations.

This package provides the components necessary for developing
Linuxconf modules outside of the linuxconf source tree and/or
developing stand-alone utilities using the linuxconf interface
toolkit.

Install linuxconf-devel if you want to develop Linuxconf modules.
You must also have linuxconf installed.

%prep
%setup -q
%patch0 -p0
%patch2 -p0
%patch4 -p0
%patch5 -p1
%patch100 -p0
%patch102 -p0
%patch103 -p0
%patch104 -p1
%patch200 -p0
%patch300 -p0
%patch301 -p0
%patch302 -p0
%patch303 -p0

pushd conf.files/redhat/scripts && {
 mv -f S99linuxconf linuxconf
 rm -f S00linuxconf grabinfo.sh
} && popd

cd $RPM_BUILD_DIR/%{name}-%{PACKAGE_VERSION}/help.files
 for files in [a-z][a-z];do cd $files/main; \
 perl -p -i -e "s/linux.org/linux-mandrake.com/g;" introweb.src; \
 perl -p -i -e "s/power.gif/power.png/g;" introweb.src;cd ../..;done
 cd sources/main
 perl -p -i -e "s/linux.org/linux-mandrake.com/g;" introweb.src; \
 perl -p -i -e "s/power.gif/power.png/g;" introweb.src;cd ../..
cd $RPM_BUILD_DIR/%{name}-%{PACKAGE_VERSION}/userconf
 perl -p -i -e "s/linux.org/linux-mandrake.com/g;" upass.cc; \
 perl -p -i -e "s/power.gif/power.png/g;" upass.cc;cd ..

install -m644 %{SOURCE1} images/power.png

%build
cd misc 
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

### When applying non-official patches to the tree, we have
### to re-build the message files
cd ../translate
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"
cd ../userconf
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" msg
cd ..
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
export RPM_BUILD_ROOT

uid=`id -un` && gid=`id -gn`
find . -name Makefile -o -name "*.mak" -o -name "*.sh" \
| xargs perl -pi -e "s/(install.*)-o ?root/\$1/; s/(install.*)-g ?root/\$1/; s/(chown.*)root\.root/\$1$uid.$gid/"

make install_for_rpm

mkdir -p $RPM_BUILD_ROOT/var/log/linuxconf
for file in htmlaccess netconf ; do
        touch $RPM_BUILD_ROOT/var/log/linuxconf/$file.log 
        chmod 600 $RPM_BUILD_ROOT/var/log/linuxconf/$file.log
done

rm -f $RPM_BUILD_ROOT/usr/lib/linuxconf/install/*{caldera,conectiva,debian,suse}*
cp $RPM_BUILD_ROOT/usr/lib/linuxconf/install/conf.linuxconf-redhat-4.x  $RPM_BUILD_ROOT/etc/conf.linuxconf

make install-devel
make install-lib

# Fix symlinks
for i in userconf netconf fsconf;do
ln -sf linuxconf $RPM_BUILD_ROOT/bin/$i
done
for i in askrunlevel dnsconf fixperm mailconf;do
ln -sf ../bin/linuxconf $RPM_BUILD_ROOT/sbin/$i
done

mkdir -p $RPM_BUILD_ROOT/usr/lib/menu/
cat << EOF > $RPM_BUILD_ROOT/usr/lib/menu/%{name}
?package(%{name}):needs="text" section="Configuration/Other" \
title="LinuxConf-Text" command="/bin/linuxconf" \
description="An extremely capable system configuration tool." \
icon=kcontrol.xpm

?package(%{name}):needs="text" section="Configuration/Networking" \
title="Netconf-Text" command="/bin/netconf" \
description="Configuration of your network." \
icon=network_settings.xpm

?package(%{name}):needs="text" section="Configuration/Other" \
title="Netconf-Text" command="/bin/userconf" \
description="Administration of users." \
icon=kuser.xpm
EOF

(cd $RPM_BUILD_ROOT/usr/lib/linuxconf; find . -type f -print) | 
  grep -v '^\./help\.' | grep -v '^\.$' |
  sed 's:^\./:/usr/lib/linuxconf/:g' > libfiles
(cd $RPM_BUILD_ROOT/usr/lib/linuxconf; find . -type d -print) | 
  grep -v '^\./help\.' | grep -v '^\.$' |
  sed 's:^\./:%dir /usr/lib/linuxconf/:g' >> libfiles

%clean
if [ "$RPM_BUILD_ROOT" != "/" ] ; then
	rm -rf $RPM_BUILD_ROOT
fi

%pre
OLDINSTALL=/usr/lib/linuxconf/help.eng/notices/01-oldinstall
INITTABREPLACE=/usr/lib/linuxconf/uninstall/inittab.replace
UPGRADE="NO"

# Check for tarball installation
if [ -f /usr/lib/linuxconf/conf.daemons ] ; then
	UPGRADE="YES"
fi

if [ -f /usr/lib/linuxconf/std/conf.daemons ] ; then
	UPGRADE="YES"
fi

# Check for old 1.9r22 RPM installation
if [ -f /usr/lib/linuxconf/install/doinst.sh ] ; then
	UPGRADE="YES"
fi

if [ $UPGRADE = "YES" ] ; then
	# Script to upgrade pre-1.9r25 Linuxconf to new SysV compliant booting.
	# Dale - Hacked in a few minutes late one night :-)

	# Kill the Install directory
	if [ -f /install/doinst.sh ] ; then
		rm -Rf /install
	fi

	# Kill the old /usr/lib/linuxconf directory, the RPM will put
	# everything we need back in later.
	rm -Rf /usr/lib/linuxconf

	# Create the directories we will need for the upgrade
	install -d -g users -m 755 -o root /usr/lib/linuxconf/
	install -d -g users -m 755 -o root /usr/lib/linuxconf/help.eng/notices/
	install -d -g users -m 755 -o root /usr/lib/linuxconf/uninstall/

	# Create a note displayed by linuxconf informing that the RPM
	# install has done some cleanup
	echo "      Installation note" >$OLDINSTALL
	echo >>$OLDINSTALL
	echo "The RPM installation has detected that linuxconf was already" >>$OLDINSTALL
	echo "installed using the tar.gz kit" >>$OLDINSTALL
	echo >>$OLDINSTALL
	echo "It has taken action to fix your linuxconf installation" >>$OLDINSTALL
	echo "so it becomes more compatible with RPM based systems" >>$OLDINSTALL
	echo >>$OLDINSTALL

	# I put a default RedHat inittab in /usr/lib/linuxconf/install
	# When I unpack the distro, the original SHOULD be there, but hey,
	# You never can tell when someone is gonna need that 1k taken up
	# by the backup....
	if [ -f /etc/inittab.old ] ; then
		cp /etc/inittab /usr/lib/linuxconf/uninstall/inittab.beforeupgrade
		mv -f /etc/inittab.old /etc/inittab
	#else
		# Tell the RPM to replace this file with a stock RedHat
		# We haven't untarred anything yet, so we can't replace it
		#cp /etc/inittab /usr/lib/linuxconf/uninstall/inittab.beforeupgrade
		#touch $INITTABREPLACE
	fi

	if [ -f /etc/rc.d/rc.M ] ; then
		mv -f /etc/rc.d/rc.M /usr/lib/linuxconf/uninstall/rc.M.beforeupgrade
	fi

	if [ -f /usr/sbin/syslogd.old ] ; then
		mv -f /usr/bin/syslogd.old /usr/lib/linuxconf/uninstall/syslogd.beforelinuxconf
	fi

	if [ -f /etc/conf.linuxconf ] ; then
		mv -f /etc/conf.linuxconf /etc/conf.linuxconf-installed
	fi
fi

%post
touch /var/log/linuxconf/htmlaccess.log
touch /var/log/linuxconf/netconf.log

/usr/lib/linuxconf/install/rpm-postinst.sh $*

# Add a few group ids so that the user is not prompted for them later...

# if it is an old version of groupadd, the combined -g and -r options
# will cause it to fail, so we fall back on just -r.  It will be less
# consistent across systems, but that's not too horrible.
/usr/sbin/groupadd -g 230 -r -f pppusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f pppusers >/dev/null
/usr/sbin/groupadd -g 231 -r -f popusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f popusers >/dev/null
/usr/sbin/groupadd -g 232 -r -f slipusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f slipusers >/dev/null
echo "[netaccess]" >> /etc/conf.linuxconf
echo "htmlaccess.from 127.0.0.1 255.255.255.255" >> /etc/conf.linuxconf
echo "htmlaccess.dolog 0" >> /etc/conf.linuxconf
echo "htmlaccess.enable 1" >> /etc/conf.linuxconf
/sbin/ldconfig

# Those are not needed since 1.17
#%triggerin -- netkit-base
## Update /etc/inetd.conf
#if grep -v '^linuxconf' /etc/inetd.conf >/dev/null 2>&1 ; then
#        echo >> /etc/inetd.conf
#        echo linuxconf stream tcp wait root /bin/linuxconf linuxconf --http >> /etc/inetd.conf
#        if [ -f /var/run/inetd.pid ] ; then
#                kill -HUP `cat /var/run/inetd.pid`
#        fi
#fi
#
#%triggerin -- setup
## Update /etc/services
#if grep -v '^linuxconf' /etc/services >/dev/null 2>&1 ; then
#  echo "linuxconf 98/tcp" >> /etc/services
#fi

if [ -x /usr/bin/update-menus ];then
		/usr/bin/update-menus
fi

%triggerin -- named
/bin/linuxconf --setmod dnsconf
%triggerin -- dhcpd
/bin/linuxconf --setmod dhcpd
%triggerin -- sendmail
/bin/linuxconf --setmod mailconf
%triggerin -- apache
/bin/linuxconf --setmod apache
%triggerin -- samba
/bin/linuxconf --setmod samba
%triggerin -- wu-ftpd
/bin/linuxconf --setmod wuftpd
%triggerun -- named
# we do not use --unsetmod because we want to leave a module that is
# explicitly turned off that way even if the triggered package is
# afterwards reinstalled...
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 dnsconf$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- dhcpd
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 dhcpd$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- sendmail
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 mailconf$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- apache
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 apache$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- samba
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 samba$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- wu-ftpd
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 wuftpd$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }

%preun
# The script is handed a 0 if this is a uninstall
# and a 1 if it is an upgrade...
/usr/lib/linuxconf/install/rpm-preuninst.sh $1

%postun
if [ "$1" = 0 ] ; then

	# remove linuxconf from /etc/inetd.conf if it is there
	if [ -f /etc/inetd.conf ] &&
   	grep linuxconf /etc/inetd.conf >/dev/null 2>&1 ; then
		if grep -v linuxconf /etc/inetd.conf > /tmp/inetd.$$ ; then
			mv /tmp/inetd.$$ /etc/inetd.conf
		fi
	fi

	rm -f /var/run/treemenu.cache

		if [ -x /usr/bin/update-menus ];then
				/usr/bin/update-menus
		fi

fi


%files 
%defattr(-,root,root)
%config(noreplace) %verify(not md5 size mtime) /etc/conf.linuxconf
%config /etc/pam.d/linuxconf
%config /etc/pam.d/linuxconf-pair
%config /etc/logrotate.d/linuxconf
/usr/lib/menu/*
/usr/lib/linuxconf
/bin/linuxconf
/bin/netconf
/bin/fsconf
/sbin/askrunlevel
/sbin/dnsconf
/sbin/fixperm
/sbin/mailconf
/bin/userconf
/bin/remadmin

%dir /var/log/linuxconf
%ghost /var/log/linuxconf/htmlaccess.log
%ghost /var/log/linuxconf/netconf.log

%doc rpmfiles/doc/COPYING
%doc rpmfiles/doc/HELPING
%doc rpmfiles/doc/RPM-CHANGES
%doc rpmfiles/doc/RPM-INSTALL
%doc rpmfiles/doc/RPM-README
%doc rpmfiles/doc/UPGRADE

%files devel
%defattr(-,root,root)
/usr/lib/*.s*
/usr/include/linuxconf
/usr/lib/liblinuxconf.a
/usr/lib/linuxconf-devel

%changelog
* Sun May  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.18-2mdk
- Don't try to upgrade lilo everytime (we use also grub).
- 1.18, fix bugs of preview before quit.

* Sun Apr 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r9-2mdk
- Add support for interactive runlevel.

* Fri Apr  7 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r9-1mdk
- merged my patches into main linuxconf source with Jacques Gelinas
- fixed symlinks askrunlevel, dnsconf, fixperm and mailconf.

* Mon Apr  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r7-7mdk
- Chmou bad days adding a menu entry.

* Mon Apr  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r7-6mdk
- move .so to -devel package (and make rpmlint happy).
- Fix groups.
- Fix relative symlinks.

* Sat Apr  1 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r7-5mdk
- Touch /var/log/linuxconf{htmlaccess,netconf}.log in %post for logrotate

* Fri Mar 24 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r7-4mdk
- spelling patch
- remadmin is not a config file
- used spec-helper to clean rpm.

* Mon Mar 20 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r7-3mdk
- re-added mayshowexpire flag in userconf

* Mon Mar 20 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r7-2mdk
- fixed dhcp patch

* Mon Mar 20 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r7-1mdk
- 1.17r7
- added dhcp patch
- added userconf patch, then removed it because Jacques Gelinas reads my 
  mind ;-) and it was already there.

* Tue Mar  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r5-1mdk
- 1.17r5.

* Wed Mar  1 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r4-2mdk
- added support for ADSL PPPoE linuxconf module

* Wed Mar  1 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.17r4-1mdk
- fixed broken fwport.cc 
- put setup -q so "tar" won't take a week to do its job
- added ldconfig in post section
- added liblinuxconf.so (required by some modules)
- fixed translations
- added network access for 127.0.0.1
- worked successfully with Jacques Gelinas <jack@solucorp.qc.ca> to
  integrate my virtual hosting patches in Linuxconf's main release
- corrected some broken buttons in french version
- added french translations
- changed the link to linux.org to linux-mandrake.com, removed it from the
  mdkconf.patch and put it in the spec file so new translations will work
  without changing the patch.
- removed some trigger scripts that are not needed anymore and caused
  linuxconf to appear twice in inetd.conf and services
- fixed languages so that all languages are installed and the user can
  switch after installation. Important in cases where the sysadmin speaks
  another language than the desktop users (ie ISPs).
- put dialout module instead of redhatppp because it's better for
  most ISPs and works with dedicated lines.

* Tue Feb 22 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r3-4mdk
- logorotate should also follow the change of /var/log/linuxconf/

* Wed Feb 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r3-3mdk
- fix url to point to http://www.linuxmandrake.com/.

* Wed Feb 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r3-2mdk
- Oops forget to insert the /var/log/linuxconf directory

* Wed Feb 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.17r3-1mdk
- Real clock is /sbin/hwclock.
- Move logs to /var/log/linuxconf/.
- Spec tweak.
- Fix url.
- 1.17r3.

* Mon Jan 17 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.16r10-6mdk
- added a BuildRequires gd-devel
- fix build on sparc.

* Tue Jan 11 2000 Pixel <pixel@mandrakesoft.com>
- fix an imprecision in call to method setfrom
- fix build as non-root

* Mon Dec 27 1999 Frederic Lepied <flepied@mandrakesoft.com> 1.16r10-3mdk
- add XAUTHORITY to the environment of new processes.

* Mon Dec 20 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- New logo from helene.

* Wed Dec  8 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- removed lpconf and xconf.
- Support png not gif.
- 1.16r10.

* Mon Nov 22 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Re-remove the treemenu.

* Thu Oct 21 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- New beautifull logo from alix :).
- 1.16r4.

* Thu Sep 09 1999 Thierry Vignaud <tvignaud@mandrakesoft.com>
- 1.16r3.1

* Thu Aug  5 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- 1.16r2
- Patched heavily to get it to work.
- Add trigger rules from redhat packages.
- Please TEST it.

* Fri Jul 16 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Back to 1.15r2, the 16r1 is completely broken the install and boot. (i'll
  fix it this monday if no other has done this before me ;)).

* Fri May 14 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- We don't want tree menus.
- Merging the -anl patch to mdkconf (i will split lather).
- Fix a bug in the %postun scripts.

* Wed Apr 21 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.com>
- update to 1.15
- handle RPM_OPT_FLAGS
- handle modems at /dev/ttyS3

* Mon Apr 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Mandrake specification.
- Fixing typo.

* Mon Apr 05 1999 Michael K. Johnson <johnsonm@redhat.com>
- prerequire redhat-release
- remove ghost reference to boot.log in logrotate file.

* Wed Mar 31 1999 Michael K. Johnson <johnsonm@redhat.com>
- dhcpd config should trust dhcpd or dhcpd script to put in correct routes

* Tue Mar 30 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to 1.14r2
- added defattr

* Mon Mar 29 1999 Michael K. Johnson <johnsonm@redhat.com>
- fixed ppp device names
- added a bunch of modules by default

* Thu Mar 25 1999 Michael K. Johnson <johnsonm@redhat.com>
- removed /var/log/boot.log (not used on Red Hat Linux)
- add redhatppp module by default
- fix /var/spol/mqueue permissions

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Thu Mar 18 1999 Michael K. Johnson <johnsonm@redhat.com>
- do not install old versions of patch files
- perm -> umask to fix bug #418

* Mon Mar 15 1999 Michael K. Johnson <johnsonm@redhat.com>
- french messages

* Thu Mar 11 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved to 1.14

* Wed Mar 10 1999 Michael K. Johnson <johnsonm@redhat.com>
- Moved to pristine source from internal CVS archive
